//+----------------------------------------------------------------------------+
//|                                                 test_DateBeginQuarter.mq4  |
//|                                                                            |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  12.05.2008      DateBeginQuarter().           |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link  "http://www.kimiv.ru"
#property show_inputs

extern int nq=-2;

void start() {
  Message(TimeToStr(DateBeginQuarter(nq)));
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.05.2008                                                     |
//|   :                                    |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|                                    (-2 - )                      |
//|                                    (-1 - )                          |
//|    nq -               ( 0 - )                          |
//|                                    ( 1 - )                        |
//|                                    ( 2 - )                      |
//+----------------------------------------------------------------------------+
datetime DateBeginQuarter(int nq=0) {
  int ye=Year()-MathFloor(nq/4);
  nq=MathMod(nq, 4);
  int mo=Month()-MathMod(Month()+2, 3)+3*nq;
  if (mo<1) {
    mo+=12;
    ye--;
  }
  if (mo>12) {
    mo-=12;
    ye++;
  }

  return(StrToTime(ye+"."+mo+".01"));
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+----------------------------------------------------------------------------+

